#include <fstream>
#include <limits>
#define NMax 101
using namespace std;

int N, M, A;
int INF = numeric_limits<int>::max();
int V[NMax][NMax], T[NMax][NMax];

void read()
{
	int i, j;
	ifstream fin("lacusta.in");
	fin >> N >> M;
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			fin >> V[i][j];
	fin.close();
}

int solve()
{
	int i, j, k;
	if (M == 1)
		return V[1][1];
	if (N == 1)
		return V[1][1] + V[1][M];
	for (j = 1; j < M; ++j)
		T[N][j] = V[N][j] + V[N][M];
	for (i = N - 1; i > 1; --i)
		for (j = 1; j <= M; ++j)
		{
			T[i][j] = INF;
			for (k = 1; k <= M; ++k)
				if (k != j && (i != N - 1 || k != M))
					if (T[i][j] > T[i + 1][k] + V[i][k])
						T[i][j] = T[i + 1][k] + V[i][k];
			T[i][j] += V[i][j];
		}
	T[1][1] = INF;
	for (j = 2; j <= M; ++j)
		if (1 != N - 1 || j != M)
			if (T[1][1] > V[1][j] + T[2][j])
				T[1][1] = V[1][j] + T[2][j];
	T[1][1] += V[1][1];
	return T[1][1];
}

void write()
{
	ofstream fout("lacusta.out");
	fout << A << '\n';
	fout.close();
}

int main()
{
	read();
	A = solve();
	write();
	return 0;
}
